Subject: Re: e1000e on thinkpad x60: interrupt problem

From: Jesse Brandeburg <[email-masked]>
Date: Tue, 9 Jul 2013 14:40:41 -0700

On Tue, 9 Jul 2013 22:48:54 +0200
Pavel Machek <[email-masked]> wrote:

> Yeah, of course you need to ask e1000e if it generated the
> interrupt. That part works. The part that actually generates the
> interrupt does not. Take a look at original mail...
> 
> packet comes
> e1000e sets E1000_ICR_INT_ASSERTED bit
> e1000e tries to generate an interrupt and fails
> 50msec passes

^^ thats the ASPM timeout length.

> AHCI generates interrupt
> all the handlers are called
>     AHCI processes its interrupt, handles disk read
>     e1000_intr notices E1000_ICR_INT_ASSERTED bit, delivers the packet.
> 
> Network still works, only slowly. Ping goes lower when I use the
> disk. That matches what I see.
> 
> Do you have other explanation?

Regardless of what others are saying I believe you have an issue with
ASPM being enabled.  All the discussion about shared interrupts, is
just a distraction.  This issue would still occur (and just be worse)
without a shared interrupt.

You already mentioned that a kernel hack to disable ASPM fixes it, but
you can just boot with different options to turn off ASPM.

pcie_aspm=off

There are known issues with ASPM on this part, and it definitely needs
to be off.  If your bios has the option to turn it off, that is the
best way to disable it, second choice is to turn it off using the
kernel option.

Hope this helps,
Jesse